// variable to check whether the HTML UI is hosted
// within Allegro SDA
//var isHosted = window.hasOwnProperty('cdsCPHBridge');
function isHosted() {
    return window.hasOwnProperty("cdsCPHBridge");
}

// Generic mechanism to calls Tcl procedure from JavaScript
// params: procName - name of the Tcl procedure to call
//         args - arguments to the Tcl procedure
function callTcl(procName, args, f) {
	if (isHosted()) {
		if (f != null && f != undefined) {
			window.cdsCPHBridge.orPrmConnector("executeTcl", procName + " " + args, f);
		}
		else {
			window.cdsCPHBridge.orPrmConnector("executeTcl", procName + " " + args);
		}
	}
}

function wrapArg(arg) {
	return '"' + arg + '"';
}
function Invoke0(tcl) {
	callTcl(tcl, '');
}
function Invoke1(tcl, arg1) {
	callTcl(tcl, wrapArg(arg1));
}
function Invoke2(tcl, arg1, arg2) {
	callTcl(tcl, wrapArg(arg1) + ' ' + wrapArg(arg2));
}
function Invoke3(tcl, arg1, arg2, arg3) {
	callTcl(tcl, wrapArg(arg1) + ' ' + wrapArg(arg2) + ' ' + wrapArg(arg3));
}

function doToCurve(data) {
    if (data != '') {
		Invoke2('topxp::gotoCurveLink', window.pageid, data);
    }
}

function exportReport() {
	Invoke1('topxp::exportMeasurementReport', window.pageid);
}

function openUrl(data) {
	Invoke1('topxp::openUrl', data);
}

function initTheme(theme) {
	if (theme == 'dark') {
		var darkTheme = document.createElement("link");
		darkTheme.setAttribute('rel', 'stylesheet');
		darkTheme.setAttribute('type', 'text/css');
		darkTheme.setAttribute('href', 'css/complianceStyle_dark.css');
		document.head.appendChild(darkTheme);
	}
}
function sleep(ms) {
  return new Promise(resolve => setTimeout(resolve, ms));
}
(async function initWebEngine() {
	await sleep(50);// still got empty page sometimes, add 50ms delay.
    if (!isHosted()) {
        setTimeout(initWebEngine, 10);
    } else {
		callTcl('cps::getTheme', "", initTheme);
		refresh();
    }
})();
